From 298df46891dffcf2b591dc0e4033533f271b0181 Mon Sep 17 00:00:00 2001
From: Will Morrow <wmorrow@qti.qualcomm.com>
Date: Thu, 18 Jan 2018 14:39:56 -0500
Subject: [PATCH] Implement sorting benchstat output

---
 benchstat/sort.go     | 42 ++++++++++++++++++++++++++++++++++++++++++
 cmd/benchstat/main.go | 27 +++++++++++++++++++++------
 2 files changed, 63 insertions(+), 6 deletions(-)
 create mode 100644 benchstat/sort.go

diff --git a/benchstat/sort.go b/benchstat/sort.go
new file mode 100644
index 0000000..ae4771b
--- /dev/null
+++ b/benchstat/sort.go
@@ -0,0 +1,42 @@
+package benchstat
+
+import (
+	"sort"
+)
+
+type SortType int
+
+const (
+	NoSort SortType = iota
+	BenchmarkSort
+	DeltaSort
+	ChangeSort
+)
+
+type TableSort struct {
+	Table     *Table
+	WhichSort SortType
+}
+
+func (t TableSort) Less(i, j int) bool {
+	switch t.WhichSort {
+	case DeltaSort:
+		return t.Table.Rows[i].Delta < t.Table.Rows[j].Delta
+	case ChangeSort:
+		return t.Table.Rows[i].Change < t.Table.Rows[j].Change
+	default: //default to BenchmarkSort
+		return t.Table.Rows[i].Benchmark < t.Table.Rows[j].Benchmark
+	}
+}
+func (t TableSort) Len() int { return len(t.Table.Rows) }
+func (t TableSort) Swap(i, j int) {
+	t.Table.Rows[i], t.Table.Rows[j] = t.Table.Rows[j], t.Table.Rows[i]
+}
+
+func SortTable(t *Table, reverse bool, typ SortType) {
+	toSort := sort.Interface(TableSort{t, typ})
+	if reverse {
+		toSort = sort.Reverse(toSort)
+	}
+	sort.Sort(toSort)
+}
diff --git a/cmd/benchstat/main.go b/cmd/benchstat/main.go
index 1ec3808..7d23a5c 100644
--- a/cmd/benchstat/main.go
+++ b/cmd/benchstat/main.go
@@ -110,11 +110,13 @@ func usage() {
 }
 
 var (
-	flagDeltaTest = flag.String("delta-test", "utest", "significance `test` to apply to delta: utest, ttest, or none")
-	flagAlpha     = flag.Float64("alpha", 0.05, "consider change significant if p < `α`")
-	flagGeomean   = flag.Bool("geomean", false, "print the geometric mean of each file")
-	flagHTML      = flag.Bool("html", false, "print results as an HTML table")
-	flagSplit     = flag.String("split", "pkg,goos,goarch", "split benchmarks by `labels`")
+	flagDeltaTest   = flag.String("delta-test", "utest", "significance `test` to apply to delta: utest, ttest, or none")
+	flagAlpha       = flag.Float64("alpha", 0.05, "consider change significant if p < `α`")
+	flagGeomean     = flag.Bool("geomean", false, "print the geometric mean of each file")
+	flagHTML        = flag.Bool("html", false, "print results as an HTML table")
+	flagSplit       = flag.String("split", "pkg,goos,goarch", "split benchmarks by `labels`")
+	flagSort        = flag.String("sort", "none", "sort by this `header`: benchmark, delta, change")
+	flagReverseSort = flag.Bool("revsort", false, "reverse the sort order")
 )
 
 var deltaTestNames = map[string]benchstat.DeltaTest{
@@ -127,13 +129,21 @@ var deltaTestNames = map[string]benchstat.DeltaTest{
 	"ttest":  benchstat.TTest,
 }
 
+var sortNames = map[string]benchstat.SortType{
+	"none":      benchstat.NoSort,
+	"benchmark": benchstat.BenchmarkSort,
+	"delta":     benchstat.DeltaSort,
+	"change":    benchstat.ChangeSort,
+}
+
 func main() {
 	log.SetPrefix("benchstat: ")
 	log.SetFlags(0)
 	flag.Usage = usage
 	flag.Parse()
 	deltaTest := deltaTestNames[strings.ToLower(*flagDeltaTest)]
-	if flag.NArg() < 1 || deltaTest == nil {
+	sortType, ok := sortNames[strings.ToLower(*flagSort)]
+	if flag.NArg() < 1 || deltaTest == nil || !ok {
 		flag.Usage()
 	}
 
@@ -154,6 +164,11 @@ func main() {
 	}
 
 	tables := c.Tables()
+	if sortType != benchstat.NoSort {
+		for _, table := range tables {
+			benchstat.SortTable(table, *flagReverseSort, sortType)
+		}
+	}
 
 	var buf bytes.Buffer
 	if *flagHTML {
-- 
1.9.1

